// after init
(function ($, Drupal) {

  function addDeleteButton(layout) {
    var $block_elem = $('.gjs-block-category').find('.gjs-block-label:contains("' + layout.get('label') + '")').parent();
    if ($block_elem.find('.gjs-am-close').length == 0) {

      var $btn = $('<div class="gjs-am-close">⨯</div>');
      var layout_id = layout.get('id').replace('layout', '');
      $btn.click(function () {
        if (confirm(Drupal.t("Do you really want to delete this layout?"))) {
          editor.BlockManager.remove('layout' + layout_id)
          Drupal.restconsumer.delete('/pagedesigner/layout/' + layout_id);
        }
      });
      $block_elem.append($btn);
    }
  }

  Drupal.behaviors.pagedesigner_layouts_after_init = {
    attach: function (context, settings) {
      // Add delete button to layout blocks
      $(document).on('pagedesigner-init-events', function (e, editor, options) {
        editor.on('run:open-blocks', () => {
          var layouts = editor.BlockManager.getAll().filter(layout => layout.get('category').id == 'Layouts');
          layouts.forEach(function (layout) {
            addDeleteButton(layout);
          })
        });
      });
    }
  };

})(jQuery, Drupal);
